-- XLCustom script for Expert Sleepers Augustus Loop 2.1
-- The script was written by Axel Baesler axl99@freenet.de
-- My blog (german): www.ausdemfenster.de
-- Enjoy!


-- return the window size
function getWindowSize()
	return 585, 90
end

-- return the main font
-- the return is a list of font filename and size options
-- the first one found will be used
function getFont()
	if isMac then
		return { { name="GillSans.dfont", size=14 }, { name="Monaco.dfont", size=12 } }
	else
		return { { name="tahoma.ttf", size=14 }, { name="arial.ttf", size=12 } }
	end
end
-- return the label font
function getLabelFont()
	if isMac then
		return { { name="GillSans.dfont", size=11 }, { name="Monaco.dfont", size=9 } }
	else
		return { { name="tahoma.ttf", size=11 }, { name="arial.ttf", size=9 } }
	end
end
-- return the text field font
function getTextFieldFont()
	if isMac then
		return { { name="GillSans.dfont", size=26 }, { name="Monaco.dfont", size=26 } }
	else
		return { { name="tahoma.ttf", size=22 }, { name="arial.ttf", size=22 } }
	end
end

-- create and lay out all the controls
function createUI()

	-- load textures
	atlas = texture( "buttonz.png" )
	background = texture( "background.png" )
	setBackgroundTexture( background )

	local windowW = getWindowSize()
	
	-- set location of the banner
	setBannerPosition( 70.0 )
	
	-- set outline colours for groups
	setGroupActiveColour( 1.0, 1.0, 1.0, 1.0 )
	setGroupInactiveColour( 0.48, 0.48, 0.48, 1.0 )
	
	-- constants
	local kTextFieldH = 26
	local kKnobSize = 26
	local kKnobU = 29
	local kKnobSpace = 34
	local kButtonW = 48
	local kButtonH = 21
	local kButtonSpaceH = 52
	local kButtonU = 49
	local groupSpacer = 30

		
	-- make renderers
	theKnobRenderer = knobRenderer( atlas, 6*kButtonU, 0, kKnobSize )
	theButtonRenderer = buttonRenderer( atlas )

	-- controls
	
	local x = 10
	local y = 20
	
	add(button("Prefs", "Prefs", x, 60, 6, 6, kButtonSpaceH, 0))
	
	add(textField("OSC Port Offset", "", x, y, kTextFieldH + 5, kTextFieldH))
	
	x = x + 25
	x = x + kTextFieldH
	
	loopGroup = group("Loop")
	
	loopGroup:add(paramButton( "Tap Record", x, y, kButtonW, kButtonH, 0*kButtonU, 0 ))
	x = x + kButtonSpaceH
	loopGroup:add( paramButton( "Clear Loop", x, y, kButtonW, kButtonH, 1*kButtonU, 0 ) )
	x = x + kButtonSpaceH
	loopGroup:add(textField("Beats","", x, y, 48, kTextFieldH))
	x = x + kButtonSpaceH + groupSpacer
	
	fxGroup = group("FX")
	
	fxGroup:add( paramButton( "Freeze Loop", x, y, kButtonW, kButtonH, 2*kButtonU, 0 ) )
	x = x + kButtonSpaceH
	fxGroup:add( indicator( 0 , x, y, kButtonW, kButtonH, 3*kButtonU, 0 ) )	
	x = x + kButtonSpaceH
	fxGroup:add( paramButton( "Reverse", x, y, kButtonW, kButtonH, 5*kButtonU, 0 ) )
	x = x + kButtonSpaceH + 5
	fxGroup:add(knob("Pitch", "", x, y, kKnobSize))
	x = x + kKnobSpace + groupSpacer
	
	
	levelsGroup = group("Levels")
	
	theKnobRenderer = knobRenderer(atlas, 6*kButtonU+kKnobU, 0, kKnobSize)
	levelsGroup:add(knob("Input Level", "", x, y, kKnobSize))
	
	theKnobRenderer = knobRenderer(atlas, 6*kButtonU+(2*kKnobU), 0, kKnobSize)
	x = x + kKnobSpace
	levelsGroup:add(knob("Master feedback", "", x, y, kKnobSize))
	
	theKnobRenderer = knobRenderer(atlas, 6*kButtonU+(3*kKnobU), 0, kKnobSize)
	x = x + kKnobSpace
	levelsGroup:add(knob("Effect Level", "", x, y, kKnobSize))	


end		-- of createUI()

--function toggleFilter()
--	local l = getParameter( "Filter Type" )
--	setParameter( "Filter Type", 1 - l )
--	local m = getParameter( "Saturation On/Off" )
--	setParameter( "Saturation On/Off", 1 - m )	
--end